#! /bin/sh
#KYLIN :add kylin-backuprestore

# PowerFailSafeguard and backup restore
#if [ "`mount | grep ' /backup '`" ]; then
if [ "`mount | grep 'backup'`" ]; then
    grubfile=$1

    if [[ ! -z $grubfile ]];then
    grep -n "^menuentry" $grubfile |cut -d ':' -f 1 > /var/grep_menu
        head=`sed -n '1p' /var/grep_menu`
        head_next=`sed -n '2p' /var/grep_menu`
        let begin=$head-1
        let end=$head_next-1
        # catch the orig menuentry contents and modify it for overlayfs
        sed -n "$head,$end p" $grubfile > /var/grub_overlayfs
        sed -i "${begin} r /var/grub_overlayfs" $grubfile

        # sed -i "${head} s/menuentry.*--class/menuentry \'Normal Mode\' --class/" $grubfile
        #sed -i "${head} s/menuentry.*--class/menuentry \'KylinSec OS Linux (support backup restore)\' --class/" $grubfile
        sed -i "${head_next} s/menuentry.*--class/menuentry \'KylinSec OS Linux Initialize Restore 3 (Qomolangma)\' --class/" $grubfile
        # cat the orig linux numbers
        grep -n "/vmlinuz-" $grubfile |cut -d ':' -f 1 > /var/grep_linux
        num=`sed -n '2p' /var/grep_linux`
	num_first=`sed -n '1p' /var/grep_linux`
        # overlayfs
        overlay="`mount |grep 'backup'|cut -d ' ' -f 1|sed 's/\//\\\ \//g'|sed 's/ //g'`"
        bootdev="`mount |grep ' /boot '|cut -d ' ' -f 1|sed 's/\//\\\ \//g'|sed 's/ //g'`"

        # backup and restore,use UUID to identify a partition
        overlaypart="`mount |grep 'backup'|cut -d ' ' -f 1`";tmp=$(blkid $overlaypart|awk -F'"' '{print $2}');overlayuuid="UUID=$tmp"
        bootpart="`mount |grep ' /boot '|cut -d ' ' -f 1`";tmp=$(blkid $bootpart|awk -F'"' '{print $2}');bootdevuuid="UUID=$tmp"
        if [[ $overlayuuid != 'UUID=' ]];then
            overlay=$overlayuuid
        fi
        if [[ $bootdevuuid != 'UUID=' ]];then
            bootdev=$bootdevuuid
        fi

        # support writtable partition of LVM partition
        if [[ ${overlaypart:0:12} == "/dev/mapper/" ]];then
            backuplvm=$(echo ${overlaypart:12} | sed 's/-backup/\/backup/' | sed 's/--/-/')
        elif [[ ${overlaypart:0:14} == "/dev/unikylin/" ]];then
            backuplvm=${overlaypart:5}
        fi
        backuplvm=$(echo $backuplvm | sed 's/\//\\\ \//g'|sed 's/ //g')
        overlay="$overlay rd.lvm.lv=$backuplvm"

	# grub restore
	sed -i "${num} s/\$/ boot=$bootdev rd.break=kyrestore overlayup=$overlay overlayx=/" $grubfile 
        # backuprestore 26597
        sed -i "${num_first} s/\$/ boot=$bootdev overlayup=$overlay overlayx=/" $grubfile

        # add Advance Option
        grep -n "^menuentry" $grubfile |cut -d ':' -f 1 > /var/grep_menu
        second=`sed -n '2p' /var/grep_menu`
        let begin=$second
        sed -i "${begin}i submenu 'Advance Options' { " $grubfile

        grep -n "/initramfs-" $grubfile |cut -d ':' -f 1 > /var/grep_linux
        num=`sed -n '$p' /var/grep_linux`
        let end=$num
        sed -i "${end}a } " $grubfile

        sed -i "/backup/d" /etc/fstab
    fi
fi
